-- Altera o Recovery Model para SIMPLE
ALTER DATABASE AdventureWorks2012 SET RECOVERY SIMPLE

-- Trunca o TLog
CHECKPOINT

-- BACKUP DATABASE AdventureWorks2012 TO DISK = 'D:\BkpFull.bak' WITH COMPRESSION

-- Contedo do log - todas as colunas
USE AdventureWorks2012
select * from ::fn_dblog(null, null)
Go

--conteudo do log
select [Current LSN], Operation, Context, [Transaction ID], [Log Record Length], [Previous LSN], AllocUnitName, [Page ID], [Slot ID], [Checkpoint Begin], [Checkpoint End], [Minimum LSN], SPID, [Begin Time], [Transaction Name], [Parent Transaction ID], [Lock Information], Description, [RowLog Contents 0], [RowLog Contents 1], [Log Record] from ::fn_dblog(null, null)
Go

-- LSN					identifica cada registro e garante qual aconteceu primeiro
-- tipo					begin, commit, checkpoint, update, delete, insert, modify, alloc, format, etc
-- contexto				objeto que sofreu a ao
-- ID					primeira transao?
-- Tamanho				tamanho do registro
-- Previus LSN			LSN do registro anterior
-- RowLog Contents 0	armazena o before image (undo info)
-- RowLog Contents 1	armazena o after image (redo info)
-- Log Record			representao numerica do registro

--update
USE AdventureWorks2012
Begin Transaction
UPDATE dbo.Pessoa SET nome = 'XUXA' where ID=3
Rollback

--DBCC SQLPERF
DBCC SQLPERF(LOGSPACE)